=== debian/changelog ===
ucode (0.0.20220322-1) UNRELEASED; urgency=medium

  * Initial release.

 -- Paul Spooren <mail@aparcar.org>  Sun, 20 Mar 2022 07:13:26 -0700
